=encoding utf8

=head1 NAME

Mail::Box::Parser::Lines - reading messages from file using Perl

=head1 INHERITANCE

 Mail::Box::Parser::Lines
   is a Mail::Box::Parser
   is a Mail::Reporter

=head1 SYNOPSIS

=head1 DESCRIPTION

This C<Mail::Box::Parser::Lines> implements parsing of messages
in Perl, with an ARRAY as source.

B<Hint:>
Useful when the message is already in memory.  When you plan to use this
yourself, you probably need to use L<Mail::Message::Construct::Read|Mail::Message::Construct::Read>.

Extends L<"DESCRIPTION" in Mail::Box::Parser|Mail::Box::Parser/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Parser|Mail::Box::Parser/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Parser|Mail::Box::Parser/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box::Parser/"METHODS">

 -Option           --Defined in       --Default
  fix_header_errors  Mail::Box::Parser  false
  lines                                 <required>
  source                                <required>
  trusted            Mail::Box::Parser  false

=over 2

=item fix_header_errors => BOOLEAN

=item lines => \@lines

=item source => $name

=item trusted => BOOLEAN

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Parser|Mail::Box::Parser/"Attributes">.

=over 4

=item $any-E<gt>B<defaultParserType>( [$class] )

Inherited, see L<Mail::Box::Parser/"Attributes">

=item $obj-E<gt>B<fixHeaderErrors>( [BOOLEAN] )

Inherited, see L<Mail::Box::Parser/"Attributes">

=item $obj-E<gt>B<lines>()

Returns an ARRAY with the remaining lines.

=item $obj-E<gt>B<source>()

The name of the source.

=item $obj-E<gt>B<trusted>()

Inherited, see L<Mail::Box::Parser/"Attributes">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Box::Parser|Mail::Box::Parser/"Parsing">.

=over 4

=item $obj-E<gt>B<bodyAsFile>( $fh [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyAsList>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyAsString>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<bodyDelayed>( [$chars, [$lines]] )

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<lineSeparator>()

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<readHeader>()

Inherited, see L<Mail::Box::Parser/"Parsing">

=item $obj-E<gt>B<stop>()

Inherited, see L<Mail::Box::Parser/"Parsing">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Parser|Mail::Box::Parser/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Parser|Mail::Box::Parser/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: parser $type does not extend $pkg.

Cast by C<defaultParserType()>

=item Warning: unexpected end of header in $source:\n $line

Cast by C<readHeader()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.03,
built on January 26, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

